Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util.concurrent
Class Exchanger<V>

    java.lang.Object
      java.util.concurrent.Exchanger<V>

Type Parameters:
  `V` - The type of objects that may be exchanged

    public class Exchanger<V>

extends Object

A synchronization point at which two threads can exchange objects. Each thread presents some object on entry to the `exchange` method, and receives the object presented by the other thread on return.

Sample Usage: Here are the highlights of a class that uses an `Exchanger` to swap buffers between threads so that the thread filling the buffer gets a freshly emptied one when it needs it, handing off the filled one to the thread emptying the buffer.

     class FillAndEmpty {
       Exchanger<DataBuffer> exchanger = new Exchanger();
       DataBuffer initialEmptyBuffer = ... a made-up type
       DataBuffer initialFullBuffer = ...

       class FillingLoop implements Runnable {
         public void run() {
           DataBuffer currentBuffer = initialEmptyBuffer;
           try {
             while (currentBuffer != null) {
               addToBuffer(currentBuffer);
               if (currentBuffer.full())
                 currentBuffer = exchanger.exchange(currentBuffer);
             }
           } catch (InterruptedException ex) { ... handle ... }
         }
       }

       class EmptyingLoop implements Runnable {
         public void run() {
           DataBuffer currentBuffer = initialFullBuffer;
           try {
             while (currentBuffer != null) {
               takeFromBuffer(currentBuffer);
               if (currentBuffer.empty())
                 currentBuffer = exchanger.exchange(currentBuffer);
             }
           } catch (InterruptedException ex) { ... handle ...}
         }
       }

       void start() {
         new Thread(new FillingLoop()).start();
         new Thread(new EmptyingLoop()).start();
       }
     }

Since:
  1.5

Constructor Summary
`Exchanger()` Create a new Exchanger.

Method Summary
`V` | `exchange(V x)` Waits for another thread to arrive at this exchange point (unless it is `interrupted`), and then transfers the given object to it, receiving its object in return.
`V` | `exchange(V x, long timeout, TimeUnit unit)` Waits for another thread to arrive at this exchange point (unless it is `interrupted`, or the specified waiting time elapses), and then transfers the given object to it, receiving its object in return.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Exchanger

    public Exchanger()

  Create a new Exchanger.

Method Detail

### exchange

    public V exchange(V x)
               throws InterruptedException

  Waits for another thread to arrive at this exchange point (unless it is `interrupted`), and then transfers the given object to it, receiving its object in return.

  If another thread is already waiting at the exchange point then it is resumed for thread scheduling purposes and receives the object passed in by the current thread. The current thread returns immediately, receiving the object passed to the exchange by that other thread.

  If no other thread is already waiting at the exchange then the current thread is disabled for thread scheduling purposes and lies dormant until one of two things happens:

  - Some other thread enters the exchange; or
  - Some other thread `interrupts` the current thread.

  If the current thread:

  - has its interrupted status set on entry to this method; or
  - is `interrupted` while waiting for the exchange,
  then `InterruptedException` is thrown and the current thread's interrupted status is cleared.

  Parameters:
    `x` - the object to exchange
  Returns:
    the object provided by the other thread.
  Throws:
    `InterruptedException` - if current thread was interrupted while waiting

### exchange

    public V exchange(V x,
                      long timeout,
                      TimeUnit unit)
               throws InterruptedException,
                      TimeoutException

  Waits for another thread to arrive at this exchange point (unless it is `interrupted`, or the specified waiting time elapses), and then transfers the given object to it, receiving its object in return.

  If another thread is already waiting at the exchange point then it is resumed for thread scheduling purposes and receives the object passed in by the current thread. The current thread returns immediately, receiving the object passed to the exchange by that other thread.

  If no other thread is already waiting at the exchange then the current thread is disabled for thread scheduling purposes and lies dormant until one of three things happens:

  - Some other thread enters the exchange; or
  - Some other thread `interrupts` the current thread; or
  - The specified waiting time elapses.

  If the current thread:

  - has its interrupted status set on entry to this method; or
  - is `interrupted` while waiting for the exchange,
  then `InterruptedException` is thrown and the current thread's interrupted status is cleared.

  If the specified waiting time elapses then `TimeoutException` is thrown. If the time is less than or equal to zero, the method will not wait at all.

  Parameters:
    `x` - the object to exchange
    `timeout` - the maximum time to wait
    `unit` - the time unit of the `timeout` argument.
  Returns:
    the object provided by the other thread.
  Throws:
    `InterruptedException` - if current thread was interrupted while waiting
    `TimeoutException` - if the specified waiting time elapses before another thread enters the exchange.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.